/////////////////////////////////////////////////////////////////////////
//                     C++łRS232cʐMNX
/////////////////////////////////////////////////////////////////////////
//
//̃NX̎gTv
//
//#include "RS232c.h" //̃wb_[荞݂܂B
//
//int _tmain(int argc, _TCHAR* argv[])
//{
//	RS232c rs;
//	rs.Connect();  //ڑ܂BŊep[^ݒ肵܂Bڂ̓C^[tFCXQ
//	rs.Send("test data"); //𑗐M Send(M)
//	char w[100];
//	rs.Read(w,100);  //̎M Read(charz,ǂݍޕ)
//	//́A
//	//rs.Read_CRLF(w,99); //ŌCRLFt܂ŎM@Read_CRLF(charz,zTCY)
//	printf(w);
//	//N[YKv͂܂AIuWFNgjꂽAN[Y܂
//	getchar();
//	return 0;
//}
//////////////////////////////////////////////////////////////////////////
#ifndef _RS_232C_H_
#define _RS_232C_H_

#if _MSC_VER > 1000
#pragma once
#endif

#include <windows.h>

class RS232c{
private:
	HANDLE m_hComm;
    DWORD size;
	DCB	m_Dcb;
public:
//ep[^[̐ݒɐڑ܂B Ԃl@TRUE = @FALSE = s
bool Connect(char* PortName,  //|[gw肵܂@COM1 COM2ȂǁAlCOM1
			int BaudRate,//{[[gw肵܂Bl 9600
			int ByteSize,//1oCg̃rbgw肵܂Bl 8
			int Parity,//peBw肵܂BpeBȂ: NOPARITY
						//peB: EVENPARITY
						//peB: ODDPARITY
						//ĺApeBȂ: NOPARITY
			int StopBits,//Xgbvrbgw肵܂B
							//1rbg: ONESTOPBIT
							//1.5rbg: ONE5STOPBITS
							//2rbg: TWOSTOPBITS 
							//ĺ@1rbg: ONESTOPBIT
			int RTS,		//RTSON=RTS_CONTROL_ENABLE l͖ł
			int DTR,		//DTRON=DTR_CONTROL_ENABLE l͖ł
			int ReadTimeOut,//M̃^CAEg@msŎw@ĺ@5000ms
			int WriteTimeOut//M̃^CAEg@msŎw@ĺ@20000ms
			);
//̎M Read(charz,ǂݍޕ) Ԃl@TRUE = @FALSE = s
bool Read(char* Buff,int NumberOfCharactersToRead);
//̎M Read_CRLF(charz,obt@[TCY) Ԃl@TRUE = @FALSE = s
//CRLFLb`ƂɎM܂Aǂݍݕ񂪃obt@[TCYӂꂽꍇ
//̎_܂ł̕񂵂Mł܂
bool Read_CRLF(char* Buff,int NumberOfCharactersToRead);
//𑗐M Send(M) Ԃl@TRUE = @FALSE = s
bool Send(char* word);
//ڑ̏Ԃ擾܂
bool RS232c::isLink();
//fXgN^@|[g܂
~RS232c();
};

bool RS232c::Connect(char* PortName="COM1",
			int BaudRate = 9600,
			int ByteSize = 8,
			int Parity = NOPARITY,
			int StopBits = ONESTOPBIT,
			int RTS = RTS_CONTROL_DISABLE,
			int DTR = DTR_CONTROL_DISABLE,
			int ReadTimeOut =5000,
			int WriteTimeOut = 20000   
			)
{
		//COM10 ȏ̃VA |[gɂڑł悤ɏC 2023/08/22
		//ԍ݂̂̏ꍇɂ͑O"COM"t
		char str[32];
		if(PortName[0]=='C'){
			strcpy(str,"\\\\.\\");
		}else{
			strcpy(str,"\\\\.\\COM");
		}
		strcat(str,PortName);
		PortName=str;
		//CI

	    m_hComm = CreateFile( 
            PortName,
            GENERIC_READ | GENERIC_WRITE,
            0,
            0,
            OPEN_EXISTING,
            FILE_ATTRIBUTE_NORMAL,
            0
            );

	if( m_hComm == INVALID_HANDLE_VALUE ) return FALSE;

	//@CxggpȂ悤ɃZbg
	SetCommMask( m_hComm, 0 );
	//@o̓obt@̋eʐݒ
	SetupComm( m_hComm, 2000L, 2000L );

	//@^CAEg̃Zbg
	COMMTIMEOUTS	m_CommTime;
	m_CommTime.ReadIntervalTimeout = 0xFFFFFFFF;
	m_CommTime.ReadTotalTimeoutMultiplier = 0;
	m_CommTime.ReadTotalTimeoutConstant = ReadTimeOut;
	m_CommTime.WriteTotalTimeoutMultiplier = 0;
	m_CommTime.WriteTotalTimeoutConstant = WriteTimeOut;

	//@^CAEg̐ݒ
	SetCommTimeouts( m_hComm, &m_CommTime);

	

	//@ʐMfoCX̎擾
	GetCommState( m_hComm, &m_Dcb );

	//@ʐMfoCX̏C
	m_Dcb.DCBlength = sizeof( DCB );
	m_Dcb.fBinary = FALSE;
	m_Dcb.BaudRate = BaudRate;
	m_Dcb.ByteSize = ByteSize;
	m_Dcb.Parity = Parity;
	m_Dcb.StopBits = StopBits;
	m_Dcb.fRtsControl = RTS;
	m_Dcb.fDtrControl = DTR;
	m_Dcb.fDsrSensitivity = FALSE;
	m_Dcb.fAbortOnError = FALSE;
	m_Dcb.fNull = TRUE;
	m_Dcb.fParity =TRUE;
	m_Dcb.ErrorChar =0x00;
	m_Dcb.fErrorChar = TRUE;


	SetCommState( m_hComm, &m_Dcb ) ;
	if( !SetCommState( m_hComm, &m_Dcb ) ) return FALSE;
	
	return TRUE;
}

bool RS232c::Read(char* Buff,int NumberOfCharactersToRead){
		for(int i=0;i<NumberOfCharactersToRead;i++){
		Buff[i]='\0';
		}
		if(0==ReadFile(m_hComm,Buff,NumberOfCharactersToRead, &size,NULL)){
			return FALSE;
		}else{
			return TRUE;
		}
}

bool RS232c::Read_CRLF(char* Buff,int NumberOfCharactersToRead){

	for(int i=0;i<NumberOfCharactersToRead;i++){
		Buff[i]='\0';
	}
	char buf[10]="";
	char beChar=0x00;
	bool flag=TRUE;
	int c=0;

	while((!(buf[0]==0x0A && beChar==0x0D)) && c<NumberOfCharactersToRead && isLink()){
		buf[0]=0x00;

		if(0==ReadFile(m_hComm,buf,1, &size,NULL)){
			flag=FALSE;
		}else{
			flag=TRUE;
		}
		if(buf[0]!=0x00 && flag){
			if(c>1) beChar=Buff[c-1];
			Buff[c++]=buf[0];
		}else{
			return FALSE;
		}
	}
	return TRUE;
}

bool RS232c::Send(char* word){
	if(0==WriteFile(m_hComm,word,strlen(word),&size, NULL)){
		return FALSE;
	}else{
		return TRUE;
	}
}

bool RS232c::isLink(){
	if(m_Dcb.fDtrControl == DTR_CONTROL_ENABLE){ //DTRL̏ꍇ̂ݗL
		DWORD   dwSts;
		BOOL    fSuccess = GetCommModemStatus( m_hComm, &dwSts );    // MXe[^X̎擾
		if( !fSuccess ){
		} else {
			if(!(dwSts & MS_DSR_ON))	return FALSE;			//crqMnm
			//if(dwSts & MS_CTS_ON) //CTSON
			//if(dwSts & MS_RING_ON) //RINGON
			if(!(dwSts & MS_RLSD_ON))  return FALSE;			//RLSDON
		}
	}
	return TRUE;
}


RS232c::~RS232c(){
	//|[g܂
	CloseHandle(m_hComm);
}



#endif // _RS_232C_H_